<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->
<script setup lang="ts">
import { computed, nextTick, onMounted, ref, inject } from 'vue';
import { franc } from 'franc';
import { storeToRefs } from 'pinia';
import ChatBubble from '@/components/general/ChatBubble.vue';
import { useClipboard } from '@vueuse/core';
import { useBaseStore } from '@/stores/base';
//@ts-ignore
import MarkdownRenderer from '@/components/general/MarkdownRenderer.vue';
import { useI18n } from 'vue-i18n';
import { useChatStore } from '@/stores/chat';

const configuration = inject<any>('configuration');
const { t } = useI18n()
const $t = t;

const baseStore = useBaseStore();
const { message: notificationMessage } = storeToRefs(baseStore);
const chatStore: any = useChatStore();
const { isShared } = storeToRefs(chatStore);

enum MessageOption {
    SHORT = "short",
    LONG = "long",
    EASY = "easy",
    HARD = "hard"
}

const props = defineProps<{
    user: string,
    avatar?: string,
    message: string,
    isLast?: boolean,
    option?: string,
    copyHandler?: boolean,
    disabled?: boolean
}>();

const emits = defineEmits<{
    (e: 'option', type: string): void
}>();


const { copy } = useClipboard();

const iso6393ToBCP47: any = {
    eng: 'en-US',
    fra: 'fr-FR',
    deu: 'de-DE',
    ita: 'it-IT',
    por: 'pt-BR',
    nno: 'no-NO',
    spa: 'es-ES',
    nld: 'nl-NL',
    dan: 'da-DK',
    tuk: 'tr-TR',
    arb: 'ar-SA',
    rus: 'ru-RU',
    nds: 'de-DE',
    pol: 'pl-PL',
};

const isSpeaking = ref(false);
let utterThis: SpeechSynthesisUtterance;

let startStopInterval;

onMounted(() => {
    nextTick(() => {
        utterThis = new SpeechSynthesisUtterance();
        utterThis.onend = () => {
            startStopInterval = null;
            isSpeaking.value = false;
        }
    });

});

const handleRead = async () => {
    if (!isSpeaking.value && utterThis) {
        const container = content.value.containerRef;
        const text = container.textContent || container.innerText || "";
        utterThis.text = text;
        const langCode = franc(text);
        const bcp47Tag = /[а-яА-Я]/g.test(text) ? 'ru-RU' : iso6393ToBCP47[langCode] && await checkLanguageSupport(iso6393ToBCP47[langCode]) ? iso6393ToBCP47[langCode] : 'de-DE';
        const synth = window.speechSynthesis;
        utterThis.lang = bcp47Tag;
        synth.speak(utterThis);

        isSpeaking.value = true;
        startStopInterval = setInterval(() => {
            synth.pause();
            synth.resume();
        }, 10000);
    } else {
        speechSynthesis.cancel();
        startStopInterval = null;
        isSpeaking.value = false;
    }
};

const checkLanguageSupport = async (languageTag: string) => {
    return await new Promise((resolve) => {
        function performCheck() {
            const voices = speechSynthesis.getVoices();
            const isSupported = voices.some(voice => voice.lang === languageTag);
            resolve(isSupported);
        }

        if (speechSynthesis.getVoices().length > 0) {
            performCheck();
        } else {
            speechSynthesis.onvoiceschanged = function () {
                performCheck();
                speechSynthesis.onvoiceschanged = null;
            };
        }
    });
};

const handleCopy = () => {
    copy(props.message);
    notificationMessage.value = $t('ai.chat.notification.copy.label');
};

const handleMessageOption = (option: MessageOption) => {
    emits('option', option.valueOf())
};

function handleCopySourceCode(element: HTMLElement) {
    //@ts-ignore
    const text = element.parentElement?.previousElementSibling?.innerText;
    copy(text);
    notificationMessage.value = $t('ai.chat.notification.copySourceCode.label');
};

function handleAddCopySourceCodeEventListeners() {
    setTimeout(()=>{
        const bubbleElements = bubbleContent.value.querySelectorAll('.copy-button');
        if (bubbleElements && bubbleElements.length > 0) {
            bubbleElements.forEach((button: any) => {
                button.addEventListener('click', function () {
                    //@ts-ignore
                    handleCopySourceCode(this);
                });
            });
        }
    },1000);
};

onMounted(() => {
    if (props.copyHandler) {
        setTimeout(() => {
            handleAddCopySourceCodeEventListeners();
        }, 1000);
    }
});

const content = ref<any>();

// use async for tooltips because rendering is taking so long otherwise

const bubbleContent = ref<any>();

const getAvatarPath = computed(() => {
    return configuration.apiServer + props.avatar;
});
</script>
<template>
    <div class="flex gap-2 w-full" :class="user === 'system' ? 'flex-row' : 'flex-row-reverse'">
        <div class="min-w-8 min-h-8 max-w-8 max-h-8">
            <div class="min-w-8 min-h-8 max-w-8 max-h-8 rounded-full text-center leading-8"
                :class="user === 'system' ? 'bg-gray-300 text-gray-500' : 'bg-accent1-default text-accent1-text'" v-if="!avatar"><i
                    class="ri-user-line ri-lg"></i></div>
            <img class="min-w-8 min-h-8 max-w-8 max-h-8 rounded-full object-contain" :src="getAvatarPath" v-else>
        </div>
        <div class="w-fit max-w-[calc(100dvw-49%)]">
            <ChatBubble :position="user === 'system' ? 'left' : 'right'" :color="(disabled && disabled === true)? '#dedede80' : user === 'system' ? '#e2e8f0' : '#ffffff'">
                <div class="bg-gray-300 w-fit rounded-b-md px-2 -mt-4 select-none" v-if="option">
                    <div>{{ $t(`ai.chat.option.${option}.label`) }}</div>
                </div>
                <div class="flex flex-col gap-2" ref="bubbleContent">
                    <MarkdownRenderer :source="message" ref="content" />
                    <div class="flex flex-row gap-2 h-4" :class="user === 'system' ? 'ml-0' : 'ml-auto'">
                        <div class="flex flex-row gap-2" v-show="user === 'system' && isShared">
                            <Tooltip :tooltip="$t('ai.chat.option.short.label')" v-if="isLast && !disabled">
                                <button class="rounded-md hover:bg-gray-300 size-5"
                                    @click="() => handleMessageOption(MessageOption.SHORT)"><i
                                        class="ri-contract-up-down-line"></i></button>
                            </Tooltip>
                            <Tooltip :tooltip="$t('ai.chat.option.long.label')" v-if="isLast && !disabled">
                                <button class="rounded-md hover:bg-gray-300 size-5"
                                    @click="() => handleMessageOption(MessageOption.LONG)"><i
                                        class="ri-expand-up-down-line"></i></button>
                            </Tooltip>
                            <Tooltip :tooltip="$t('ai.chat.option.easy.label')" v-if="isLast && !disabled">
                                <button class="rounded-md hover:bg-gray-300 size-5"
                                    @click="() => handleMessageOption(MessageOption.EASY)"><i
                                        class="ri-weight-line"></i></button>
                            </Tooltip>
                            <Tooltip :tooltip="$t('ai.chat.option.hard.label')" v-if="isLast && !disabled">
                                <button class="rounded-md hover:bg-gray-300 size-5"
                                    @click="() => handleMessageOption(MessageOption.HARD)"><i
                                        class="ri-weight-fill"></i></button>
                            </Tooltip>
                        </div>
                        <Tooltip :tooltip="$t('ai.chat.option.copy.label')">
                            <button class="rounded-md hover:bg-gray-300 size-5" @click="handleCopy"><i
                                    class="ri-clipboard-line"></i></button>
                        </Tooltip>
                        <Tooltip :tooltip="$t('ai.chat.option.read.label')">
                            <button class="rounded-md hover:bg-gray-300 size-5" @click="handleRead"><i
                                    :class="isSpeaking ? 'ri-stop-fill' : 'ri-speak-line'"></i></button>
                        </Tooltip>
                    </div>
                </div>
            </ChatBubble>
        </div>
    </div>
</template>